/*
 *	ff4item.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF4ITEM_H)
#define FF4ITEM_H

#include "ff4define.h"
#include "ff4magic.h"

typedef struct weapon_tag
{
	int attack_power;				/* U */
	int hit_rate;					/*  */
	int increase_strength;			/* ͏㏸ */
	int increase_speed;				/* f㏸ */
	int increase_stamina;			/* ̗͏㏸ */
	int increase_wisdom;			/* m㏸ */
	int increase_will_power;		/* _㏸ */
	int effect_no;					/* gp̌ */
	elem_t elem_attack;				/* ʏȖ */
	state_t state_attack;			/* ʏȔԕω */
	montype_t montype_attack;		/* LX^[^Cv */
	unsigned long bits_equip_chr;	/* \LN^ */
	int flag_magnetic;				/* ͂̉e󂯂 */
	int flag_throw;					/*  */
	int flag_backrow;				/* 񂩂łЗ͂ቺȂ */
	int flag_use;					/* gpɌʂ */
	int flag_good_hand;				/* Ŏ */
	int flag_weak_hand;				/* Ƃ͋t̎Ŏ */
	int flag_2handed;				/* 莝ł */
} weapon_t;

typedef struct protector_tag
{
	int defense_power;				/* h */
	int evade_rate;					/*  */
	int magic_defense_power;		/* @h */
	int magic_evade_rate;			/* @ */
	int increase_strength;			/* ͏㏸ */
	int increase_speed;				/* f㏸ */
	int increase_stamina;			/* ̗͏㏸ */
	int increase_wisdom;			/* m㏸ */
	int increase_will_power;		/* _㏸ */
	elem_t elem_defense;			/* Uւ̑ϐ */
	state_t state_defense;			/* ԕωւ̑ϐ */
	montype_t montype_defense;		/* LX^[^Cv */
	unsigned long bits_equip_chr;	/* \LN^ */
	int flag_magnetic;				/* ͂̉e󂯂 */
} protector_t;

typedef magdata_t tool_t;

union itemparam_t
{
	weapon_t weapon;		/* ACef[^ */
	protector_t protector;	/* hACef[^ */
	tool_t tool;			/* 퓬ACef[^ */
};

typedef struct itemdata_tag
{
	int type;					/* ^Cv(ITEM_TYPE_WEAPON`ITEM_TYPE_OTHER) */
	long price;					/* i */
	union itemparam_t param;	/* ACef[^ */
} itemdata_t;

enum	/* itemdata_tag.typep */
{
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_PROTECTOR,	/* h */
	ITEM_TYPE_TOOL,			/* 퓬ACe */
	ITEM_TYPE_OTHER,		/* ʏACe */
	ITEM_TYPE_NUM
};

const char *item_getname(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelem(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestate(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeflag(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeparambug(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* FF4ITEM_H */
