/*
 *	ff4monster.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF4MONSTER_H)
#define FF4MONSTER_H

#include "ff4define.h"
#include "ff4item.h"
#include "ff4magic.h"

typedef struct mondata_tag
{
	int level;					/* x */
	long hit_point;				/* qbg|Cg */
	long magic_point;			/* }WbN|Cg */
	long experience_point;		/* lol */
	long gil;					/* M */
	int attack_times;			/* U */
	int attack_power;			/* U */
	int hit_rate;				/*  */
	int defense_times;			/* h */
	int defense_power;			/* h */
	int evade_rate;				/*  */
	int magic_defense_times;	/* @h */
	int magic_defense_power;	/* @h */
	int magic_evade_rate;		/* @ */
	int magic_attack_times;		/* @U */
	int magic_power;			/*  */
	int speed;					/* f */
	int item_get;				/* ̓肵₷ */
	int flag_boss;				/* {Xł */
	elem_t elem_defense;		/* Uւ̑ϐ */
	elem_t elem_weakness;		/* _̑ */
	state_t state_attack;		/* ʏȔԕω */
	state_t state_defense;		/* ԕωւ̑ϐ */
	montype_t montype;			/* X^[^Cv */
	int item_no[4];				/* ACe */
	int actptn_no[2];			/* sp^[̔ԍ */
} mondata_t;

typedef struct monact_tag
{
	struct
	{
		size_t action_size;		/* sp^[f[^̃oCg */
		int condition_no[3];	/* Kpf[^ */
		unsigned char *action;	/* sp^[f[^ */
	} ptn[16];
} monact_t;

typedef struct monparty_tag
{
	int num[3];				/* X^[̐ */
	int monster_no[3];		/* X^[̎ */
	int flag_eggy[3];		/* 퓬JnɃX^[~XeOɓĂ */
	int flag_exist[3];		/* 퓬JnɃX^[oĂȂ */
	int flag_escape;		/* \ł */
	int flag_event;			/* Cxg퓬ł */
} monparty_t;

typedef struct monenc_tag
{
	int party_no[8];		/* X^[p[eB̎ */
} monenc_t;

typedef struct monmap_tag
{
	int area[8][8];
} monmap_t;

typedef struct triplet_tag
{
	int times;	/*  */
	int power;	/* l */
	int rate;	/* m */
} triplet_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monact_t *mon_readact(void);
monparty_t *mon_readparty(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeelem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writestate(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const monact_t *ptr_monact, const mondata_t *ptr_mondata);
int mon_writemes(const char *ptr_filename);
int mon_writeparty(const char *ptr_filename, const monparty_t *ptr_monparty);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);
void mon_freeact(monact_t *ptr_monact);

#endif /* FF4MONSTER_H */
