/*
 *	ff5character.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF5CHARACTER_H)
#define FF5CHARACTER_H

#include "ff5magic.h"

#define NUM_CHRJOBLVUPMAX	7

typedef struct chrlvup_tag
{
	long experience_point;	/* ol */
	int hit_point;			/* {qbg|Cg */
	int magic_point;		/* {}WbN|Cg */
} chrlvup_t;

typedef struct chrjob_tag
{
	int strength;		/*  */
	int speed;			/* f */
	int stamina;		/* ̗ */
	int magic_power;	/*  */

	int cmd_no[4];		/* R}h */

	int level_max;		/* őWux */
	struct
	{
		int ability_point;	/* KvAreB|Cg */
		int ability_no;		/* CAreB */
	} level[NUM_CHRJOBLVUPMAX];

	unsigned long bits_equip_item;	/* \ACe */
} chrjob_t;

typedef magdata_t cmddata_t;

typedef struct chrcmd_tag
{
	cmddata_t param;

	int time_wait;				/* R}hšʔ܂ł̎ */

	int increase_strength;		/* ͏㏸ */
	int increase_speed;			/* f㏸ */
	int increase_stamina;		/* ̗͏㏸ */
	int increase_magic_power;	/* ͏㏸ */
} chrcmd_t;

typedef struct chrabt_tag
{
	int increase_strength;		/* ͏㏸ */
	int increase_speed;			/* f㏸ */
	int increase_stamina;		/* ̗͏㏸ */
	int increase_magic_power;	/* ͏㏸ */
} chrabt_t;

const char *chr_getjobname(int index);
const char *chr_getcmdname(int index);
chrlvup_t *chr_readlvup(void);
chrjob_t *chr_readjob(void);
chrcmd_t *chr_readcmd(void);
chrabt_t *chr_readabt(void);
int chr_writelvup(const char *ptr_filename, const chrlvup_t *ptr_chrlvup);
int chr_writejob(const char *ptr_filename, const chrjob_t *ptr_chrjob);
int chr_writecmdparam(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdelem(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdstate(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writecmdflag(const char *ptr_filename, const chrcmd_t *ptr_chrcmd);
int chr_writeabtparam(const char *ptr_filename, const chrabt_t *ptr_chrabt);

#endif /* FF5CHARACTER_H */
