/*
 *	ff5decode.c
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "ff5decode.h"

/* t@Cit@^W[V̕R[h\(VOoCg) */
static const char *tbl_charcode[] =
{
	"",   "\n", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "~", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "y",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "M",  "H",  "P",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!" , "F", "?" , "H", "%",  "/",  ":",
	"u", "v", "B", "A",  "B",  "X",  "Y",  "L",  "R",  "E",  "H",  "M",  "P",  "S",  "C",  "T",
	"", "", "+",  "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "U",  "", "", "", "", "", "", "", "", "", " ",
};

/* t@Cit@^W[V̕R[h\(bZ[WpE}`oCg1oCg) */
static const char *tbl_charcode_mb1[] =
{
	/* 0x00`0x1f */
	"", "\n", "obc", "NX^", "^CN[", "t@t@", "", "",
	"", "", "", "", "", "̐_a", "", "",
	"", "", "", "", "Vhu", "~hu", "E", "",
	"GNXfX", "iu", "Ktu", "t@Xu", "Nu", "", "", "",

	/* 0x20`0xff */
	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "y",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "M",  "H",  "P",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!" , "F", "?" , "H", "!!",  "/",  "",
	"u", "v", "B", "A", "B", "ɓ", "Y", "L", "R", "Ȃ", "H", "M", "P", "cc", "傤", "́A",
	"", "Ă", "", "A", "", "w", "l", "!?", "ł",
	"(", ")", "", "̗", "PK[", "Ñ}", "",
	"mu", "", "Η͑D", "C", "傤", "A", "", "",
	"܂", "", "", "!", "ɁA", "ȂȂ", "̂͂", " ",
};

/* t@Cit@^W[V̕R[h\(bZ[WpE}`oCg2oCg) */
static const char *tbl_charcode_mb2[] =
{
	/* 0x1e */
	"", "s", "", "l", "", "", "E", "", "", "", "", "m", "D", "", "C", "",
	"l", "", "", "", "", "", "{", "", "", "o", "C", "", "", "", "", "",
	"", "S", "", "O", "", "A", "", "", "N", "", "", "", "", "g", "", "}",
	"", "X", "", "", "", "", "", "b", "n", "", "", "", "", "", "", "R",
	"v", "", "", "", "", "", "", "", "", "", "", "m", "@", "", "P", "",
	"", "B", "_", "", "", "", "", "a", "", "", "E", "", "", "q", "i", "[",
	"`", "", "", "", "b", "", "", "", "E", "k", "", "S", "E", "b", "", "",
	"", "", "K", "", "c", "e", "", "x", "o", "j", "y", "x", "L", "", "", "",
	"", "", "", "", "", "", "", "}", "", "", "", "", "", "", "", "p",
	"h", "", "", "", "", "", "", "", "", "", "", "", "z", "@", "", "",
	"", "", "", "J", "", "", "", "", "", "g", "V", "", "", "w", "", "",
	"", "", "O", "", "", "", "J", "", "", "w", "U", "", "", "^", "", "",
	"K", "", "", "", "", "H", "", "R", "", "", "", "", "", "", "@", "q",
	"R", "I", "j", "p", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "A", "C", "L", "", "", "", "Z", "", "", "", "", "", "Z", "z", "",
	"", "", "", "D", "}", "x", "", "", "", "", "", "h", "", "", "", "`",

	/* 0x1f */
	"c", "", "", "", "", "", "A", "W", "", "", "", "", "", "", "", "",
	"", "", "", "", "o", "", "", "G", "", "", "", "R", "", "", "", "",
	"", "", "", "", "", "R", "", "`", "", "b", "", "", "", "", "E", "",
	"", "", "q", "", "", "p", "M", "t", "", "", "", "", "V", "", "k", "",
	"", "", "", "N", "", "", "", "", "G", "\", "", "", "", "g", "j", "",
	"", "]", "J", "", "", "", "s", "", "", "", "", "", "J", "", "O", "T",
	"", "a", "", "", "s", "F", "", "\", "x", "X", "", "", "X", "", "[", "U",
	"", "", "o", "", "l", "", "", "", "", "", "_", "", "M", "", "a", "S",
	"", "", "d", "", "", "", "d", "{", "d", "", "g", "U", "e", "", "", "",
	"", "", "i", "", "c", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "a", "F", "", "", "", "a", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
};

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize, int flag_multibyte)
{
	int i;
	int skip_num = 0;
	char *buf_dstbuf = NULL;
	char *ptr = NULL;
	const size_t len_buf = srcbufsize * 8;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_charcode_mb1) / sizeof(tbl_charcode_mb1[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 512);

	/* `FbN */
	if (ptr_dstbuf == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcbuf == NULL || srcbufsize == 0 || dstbufsize == 0)
	{
		assert(0);
		return ptr_dstbuf;
	}

	/* ꎞobt@mۂ */
	if ((buf_dstbuf = malloc(len_buf)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* fR[h */
	memset(buf_dstbuf, '\0', sizeof(len_buf));
	if (!flag_multibyte)
	{
		for (i = 0; i < (int)srcbufsize; i++)
			strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
	}
	else
	{
		for (i = 0; i < (int)srcbufsize; i++)
		{
			if (skip_num > 0)
				skip_num--;
			else if (0x1e <= ptr_srcbuf[i] && ptr_srcbuf[i] <= 0x1f)
			{
				if (i < (int)srcbufsize - 1)
				{
					strcat(buf_dstbuf, tbl_charcode_mb2[((ptr_srcbuf[i] - 0x1e) << 8) | ptr_srcbuf[i + 1]]);
					i++;
				}
			}
			else if (ptr_srcbuf[i] == 0x05)		/* R[h */
				skip_num = 1;
			else if (ptr_srcbuf[i] == 0x16)		/* l̖O(ʏ0x02AX^[̃bZ[Wł0x16) */
				strcat(buf_dstbuf, tbl_charcode_mb1[0x02]);
			else if (ptr_srcbuf[i] == 0xcd)		/* "%"(X^[̃bZ[Wł1oCg) */
				strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
			else
				strcat(buf_dstbuf, tbl_charcode_mb1[ptr_srcbuf[i]]);
		}
	}

	/* ̋󔒂 */
	while ((ptr = strrchr(buf_dstbuf, ' ')) != NULL && *(ptr + 1) == '\0')
		*ptr = '\0';

	/* ꎞobt@̓eo͂ */
	strncpy(ptr_dstbuf, buf_dstbuf, dstbufsize - 1);
	ptr_dstbuf[dstbufsize - 1] = '\0';

	free(buf_dstbuf);
	buf_dstbuf = NULL;

	return ptr_dstbuf;
}

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename, int flag_multibyte)
{
	int i, ch;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_charcode_mb1) / sizeof(tbl_charcode_mb1[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 512);

	/* `FbN */
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
	{
		assert(0);
		return 0;
	}

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		fp_read = NULL;
		return 0;
	}

	/* fR[h */
	if (!flag_multibyte)
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode[ch], fp_write);
		}
	}
	else
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (0x1e <= ch && ch <= 0x1f)	/* }`oCg */
			{
				int ch2;
				if ((ch2 = fgetc(fp_read)) == EOF)
					break;

				fputs(tbl_charcode_mb2[((ch - 0x1e) << 8) | ch2], fp_write);
			}
			else if (0x08 <= ch && ch <= 0x0a)	/* A󔒂R[h */
			{
				for (i = 0; i < 12 - ch; i++)
					fputs(tbl_charcode_mb1[0xff], fp_write);
			}
			else if (ch == 0x0c || ch == 0x0f)	/* R[h */
				;	/* o͂Ȃ */
			else if (ch == 0x17)	/* R[h */
			{
				/* 2ǂݔ΂ */
				if (fgetc(fp_read) == EOF || fgetc(fp_read) == EOF)
					break;
			}
			else if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode_mb1[ch], fp_write);
		}
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
