/*
 *	ff5define.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF5DEFINE_H)
#define FF5DEFINE_H

enum
{
	ELEM_IDX_FIRE,		/*  */
	ELEM_IDX_ICE,		/*  */
	ELEM_IDX_THUNDER,	/*  */
	ELEM_IDX_POISON,	/*  */
	ELEM_IDX_SACRED,	/*  */
	ELEM_IDX_EARTH,		/* n */
	ELEM_IDX_WIND,		/*  */
	ELEM_IDX_WATER,		/*  */

	NUM_ELEMENT
};

enum
{
	STATE_IDX_DARKNESS,		/* È */
	STATE_IDX_ZOMBIE,		/* ]r[ */
	STATE_IDX_POISON,		/* ғ */
	STATE_IDX_LEVITATE,		/* reg */
	STATE_IDX_MINIMUM,		/* ~j} */
	STATE_IDX_TOAD,			/* ^ */
	STATE_IDX_STONE,		/* Ή */
	STATE_IDX_SWOON,		/* 퓬s\ */

	STATE_IDX_ILLUSION,		/* g */
	STATE_IDX_ILLUSION_D,	/* g(_~[) */
	STATE_IDX_SILENT,		/*  */
	STATE_IDX_BERSERK,		/* o[TN */
	STATE_IDX_CONFUSE,		/*  */
	STATE_IDX_PARALYZE,		/*  */
	STATE_IDX_SLEEP,		/*  */
	STATE_IDX_BECOME_OLD,	/* XɘV */

	STATE_IDX_REGENERATION,	/* WFl */
	STATE_IDX_INVINCIBLE1,	/* G1 */
	STATE_IDX_SLOW,			/* XE */
	STATE_IDX_HASTE,		/* wCXg */
	STATE_IDX_STOP,			/* Xgbv */
	STATE_IDX_SHELL,		/* VF */
	STATE_IDX_PROTECT,		/* veX */
	STATE_IDX_REFLECT,		/* tN */

	STATE_IDX_HANGUP,		/* nOAbv */
	STATE_IDX_DEADLY,		/* m */
	STATE_IDX_SINGING,		/* ̂Ă */
	STATE_IDX_SLIP,			/* Xbv */
	STATE_IDX_BECOME_DEATH,	/* ̐鍐 */
	STATE_IDX_REVERSE,		/* ] */
	STATE_IDX_INVINCIBLE2,	/* G2 */
	STATE_IDX_EXIT,			/* E */

	NUM_STATE
};

enum
{
	MONTYPE_IDX_UNDEAD,		/* Afbh */
	MONTYPE_IDX_UNKNOWN,	/* s */
	MONTYPE_IDX_BEAST,		/* b */
	MONTYPE_IDX_AVIS,		/* GCrX */
	MONTYPE_IDX_DRAGON,		/* hS */
	MONTYPE_IDX_BOSS,		/* {X */
	MONTYPE_IDX_DESERT,		/*  */
	MONTYPE_IDX_HUMAN,		/* l */

	NUM_MONTYPE
};

#define ELEM_FIRE		(1U << ELEM_IDX_FIRE)
#define ELEM_ICE		(1U << ELEM_IDX_ICE)
#define ELEM_THUNDER	(1U << ELEM_IDX_THUNDER)
#define ELEM_POISON		(1U << ELEM_IDX_POISON)
#define ELEM_SACRED		(1U << ELEM_IDX_SACRED)
#define ELEM_EARTH		(1U << ELEM_IDX_EARTH)
#define ELEM_WIND		(1U << ELEM_IDX_WIND)
#define ELEM_WATER		(1U << ELEM_IDX_WATER)
#define ELEM_ALL		(ELEM_FIRE	| ELEM_ICE		| ELEM_THUNDER	| ELEM_POISON	| \
						ELEM_SACRED	| ELEM_EARTH	| ELEM_WIND		| ELEM_WATER)

#define STATE_DARKNESS		(1U << STATE_IDX_DARKNESS)
#define STATE_ZOMBIE		(1U << STATE_IDX_ZOMBIE)
#define STATE_POISON		(1U << STATE_IDX_POISON)
#define STATE_LEVITATE		(1U << STATE_IDX_LEVITATE)
#define STATE_MINIMUM		(1U << STATE_IDX_MINIMUM)
#define STATE_TOAD			(1U << STATE_IDX_TOAD)
#define STATE_STONE			(1U << STATE_IDX_STONE)
#define STATE_SWOON			(1U << STATE_IDX_SWOON)
#define STATE_PERMANENT		(STATE_DARKNESS	| STATE_ZOMBIE	| STATE_POISON	| STATE_LEVITATE	| \
							STATE_MINIMUM	| STATE_TOAD	| STATE_STONE	| STATE_SWOON)

#define STATE_ILLUSION		(1U << STATE_IDX_ILLUSION)
#define STATE_ILLUSION_D	(1U << STATE_IDX_ILLUSION_D)
#define STATE_SILENT		(1U << STATE_IDX_SILENT)
#define STATE_BERSERK		(1U << STATE_IDX_BERSERK)
#define STATE_CONFUSE		(1U << STATE_IDX_CONFUSE)
#define STATE_PARALYZE		(1U << STATE_IDX_PARALYZE)
#define STATE_SLEEP			(1U << STATE_IDX_SLEEP)
#define STATE_BECOME_OLD	(1U << STATE_IDX_BECOME_OLD)
#define STATE_TEMPORARY		(STATE_ILLUSION	| STATE_ILLUSION_D	| STATE_SILENT	| STATE_BERSERK	| \
							STATE_CONFUSE	| STATE_PARALYZE	| STATE_SLEEP	| STATE_BECOME_OLD)

#define STATE_REGENERATION	(1U << STATE_IDX_REGENERATION)
#define STATE_INVINCIBLE1	(1U << STATE_IDX_INVINCIBLE1)
#define STATE_SLOW			(1U << STATE_IDX_SLOW)
#define STATE_HASTE			(1U << STATE_IDX_HASTE)
#define STATE_STOP			(1U << STATE_IDX_STOP)
#define STATE_SHELL			(1U << STATE_IDX_SHELL)
#define STATE_PROTECT		(1U << STATE_IDX_PROTECT)
#define STATE_REFLECT		(1U << STATE_IDX_REFLECT)
#define STATE_ASSISTMAG		(STATE_REGENERATION	| STATE_INVINCIBLE1	| STATE_SLOW	| STATE_HASTE	| \
							STATE_STOP			| STATE_SHELL		| STATE_PROTECT	| STATE_REFLECT)

#define STATE_HANGUP		(1U << STATE_IDX_HANGUP)
#define STATE_DEADLY		(1U << STATE_IDX_DEADLY)
#define STATE_SINGING		(1U << STATE_IDX_SINGING)
#define STATE_SLIP			(1U << STATE_IDX_SLIP)
#define STATE_BECOME_DEATH	(1U << STATE_IDX_BECOME_DEATH)
#define STATE_REVERSE		(1U << STATE_IDX_REVERSE)
#define STATE_INVINCIBLE2	(1U << STATE_IDX_INVINCIBLE2)
#define STATE_EXIT			(1U << STATE_IDX_EXIT)
#if 0
#define STATE_OTHER			(STATE_HANGUP		| STATE_DEADLY		| STATE_SINGING		| STATE_SLIP	| \
							STATE_BECOME_DEATH	| STATE_REVERSE		| STATE_INVINCIBLE2	| STATE_EXIT)
#else
#define STATE_OTHER			(STATE_DEADLY | STATE_SLIP | STATE_BECOME_DEATH | STATE_EXIT)
#endif /* 0 */

#define STATE_ALL			(STATE_PERMANENT | STATE_TEMPORARY | STATE_ASSISTMAG | STATE_OTHER)

#define MONTYPE_UNDEAD		(1U << MONTYPE_IDX_UNDEAD)
#define MONTYPE_UNKNOWN	(1U << MONTYPE_IDX_UNKNOWN)
#define MONTYPE_BEAST		(1U << MONTYPE_IDX_BEAST)
#define MONTYPE_AVIS		(1U << MONTYPE_IDX_AVIS)
#define MONTYPE_DRAGON		(1U << MONTYPE_IDX_DRAGON)
#define MONTYPE_BOSS		(1U << MONTYPE_IDX_BOSS)
#define MONTYPE_DESERT		(1U << MONTYPE_IDX_DESERT)
#define MONTYPE_HUMAN		(1U << MONTYPE_IDX_HUMAN)

#if 0
#define MONTYPE_ALL			(MONTYPE_UNDEAD	| MONTYPE_UNKNOWN	| MONTYPE_BEAST		| MONTYPE_AVIS	| \
							MONTYPE_DRAGON	| MONTYPE_BOSS		| MONTYPE_DESERT	| MONTYPE_HUMAN)
#else
#define MONTYPE_ALL			(MONTYPE_UNDEAD	| MONTYPE_BEAST		| MONTYPE_AVIS	| \
							MONTYPE_DRAGON	| MONTYPE_BOSS		| MONTYPE_DESERT	| MONTYPE_HUMAN)
#endif /* 0 */

typedef unsigned long elem_t;
typedef unsigned long state_t;
typedef unsigned long montype_t;

const char *str_getflag(int flag);
const char *str_getelem(elem_t elem, int index);
void str_printelem(FILE *stream, elem_t elem, elem_t elem_mask);
const char *str_getstate(state_t state, int index);
void str_printstate(FILE *stream, state_t state, state_t state_mask);
const char *str_getmontype(montype_t montype, int index);
void str_printmontype(FILE *stream, montype_t montype, montype_t montype_mask);

#define bits_make32(byte1, byte2, byte3, byte4)	(((unsigned long)(byte1) & 0xff) | \
												(((unsigned long)(byte2) & 0xff) <<  8) | \
												(((unsigned long)(byte3) & 0xff) << 16) | \
												(((unsigned long)(byte4) & 0xff) << 24))

#endif /* FF5DEFINE_H */
