/*
 *	ff5item.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF5ITEM_H)
#define FF5ITEM_H

#include "ff5define.h"
#include "ff5character.h"
#include "ff5magic.h"

typedef struct weapon_tag
{
	int attack_power;				/* U */
	int hit_rate;					/*  */
	int equip_type;					/* i̎ */
	int effect_type;				/* ̌ʃ^Cv */
	int critical_hit_rate;			/* NeBJqbg */
	int magic_point;				/* }WbN|Cg */
	int increase_strength;			/* ͏㏸ */
	int increase_speed;				/* f㏸ */
	int increase_stamina;			/* ̗͏㏸ */
	int increase_magic_power;		/* ͏㏸ */
	int using_effect_no;			/* gp̌ */
	int additional_effect_rate;		/* ǉʂ̔ */
	int additional_effect_no;		/* ǉ */
	elem_t elem_attack;				/* ʏȖ */
	state_t state_attack;			/* ʏȔԕω */
	montype_t montype_attack;		/* LX^[^Cv */
	elem_t elem_powerup;			/* p[Abv鑮 */
	int flag_break;					/* gpƉ */
	int flag_throw;					/*  */
	int flag_enchant;				/* @ */
	int flag_evade;					/* Uł(1) */
	int flag_evade_f;				/* Uł(2) */
	int flag_additional_effect;		/* ǉʂ(ʏǓ) */
	int flag_additional_effect_r;	/* ǉʂ(ʏUɑ) */
	int flag_initiative;			/* ŏɍUł */
	int flag_2handed;				/* 莝ł */
} weapon_t;

typedef struct protector_tag
{
	int defense_power;			/* h */
	int evade_rate;				/*  */
	int magic_defense_power;	/* @h */
	int magic_evade_rate;		/* @ */
	int weight;					/* d */
	int increase_strength;		/* ͏㏸ */
	int increase_speed;			/* f㏸ */
	int increase_stamina;		/* ̗͏㏸ */
	int increase_magic_power;	/* ͏㏸ */
	int equip_type;				/* i̎ */
	elem_t elem_half;			/*  */
	elem_t elem_none;			/*  */
	elem_t elem_absorb;			/* z */
	elem_t elem_double;			/* _ */
	elem_t elem_powerup;		/* p[Abv鑮 */
	state_t state_defense;		/* ԕωւ̑ϐ */
	state_t state_apriori;		/* ŏKpԕω */
	int flag_evade;				/* Uł */
	int flag_magic_evade;		/* @Uł */
	int flag_steal;				/* ݂₷Ȃ */
	int flag_capture;			/* ߊl₷Ȃ */
	int flag_monk_fight;		/* uƂv̌ʂ */
	int flag_mp_half;			/* 퓬̏}WbN|CgɂȂ */
	int flag_sword_dance;		/* u邬̂܂vo₷Ȃ */
	int flag_undead;			/* Afbh̓ */
} protector_t;

typedef magdata_t tool_t;

union itemparam_t
{
	weapon_t weapon;		/* ACef[^ */
	protector_t protector;	/* hACef[^ */
	tool_t tool;			/* ACef[^ */
};

typedef struct itemdata_tag
{
	int type;					/* ^Cv(ITEM_TYPE_WEAPON`ITEM_TYPE_TOOL) */
	long price_buy;				/* l */
	long price_sell;			/* l */
	int message_no;				/* bZ[W̔ԍ */
	union itemparam_t param;	/* ACef[^ */
} itemdata_t;

enum	/* itemdata_tag.typep */
{
	ITEM_TYPE_WEAPON,		/*  */
	ITEM_TYPE_PROTECTOR,	/* h */
	ITEM_TYPE_TOOL,			/* ACe */
	ITEM_TYPE_NUM
};

const char *item_getname(int index);
itemdata_t *item_readdata(void);
int item_writeparam(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelem(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestate(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeflag(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeeffect(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeparambug(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writeelembug(const char *ptr_filename, const itemdata_t *ptr_itemdata);
int item_writestatbug(const char *ptr_filename, const itemdata_t *ptr_itemdata);

#endif /* FF5ITEM_H */
