/*
 *	ff5monster.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF5MONSTER_H)
#define FF5MONSTER_H

#include "ff5define.h"
#include "ff5item.h"
#include "ff5magic.h"

typedef struct mondata_tag
{
	int level;					/* x */
	long hit_point;				/* qbg|Cg */
	long magic_point;			/* }WbN|Cg */
	long experience_point;		/* lol */
	long gil;					/* M */
	int speed;					/* f */
	int attack_power;			/* U */
	int defense_power;			/* h */
	int evade_rate;				/*  */
	int magic_attack_power;		/* @U */
	int magic_defense_power;	/* @h */
	int magic_evade_rate;		/* @ */
	int weapon_no;				/* ʏU̕ */
	int multiplier;				/* _[W{ */
	int id;						/* ID */
	elem_t elem_none;			/*  */
	elem_t elem_absorb;			/* z */
	elem_t elem_double;			/* _ */
	state_t state_defense;		/* ԕωւ̑ϐ */
	state_t state_apriori;		/* ŏKpԕω */
	montype_t montype;			/* X^[^Cv */
	int flag_capture;			/* uƂ炦v\ */
	int flag_control;			/* uv\ */
	int flag_tech_attack_up;	/* uƂ킴vɍU1.5{ʂ */
	int flag_tech_defence_down;	/* uƂ킴vɖh͖Es\ʂ */
	int flag_tech_become_old;	/* uƂ킴vɏXɘVʂ */
	int flag_tech_poison;		/* uƂ킴vɖғŌʂ */
	int flag_tech_darkness;		/* uƂ킴vɈÈŌʂ */
	int flag_tech_paralyze;		/* uƂ킴vɖ჌ʂ */
	int flag_tech_confuse;		/* uƂ킴vɍʂ */
	int flag_tech_slip;			/* uƂ킴vɃXbvʂ */
	int item_no[4];				/* ACe */
	int control_no[4];			/* uv̍s */
	int free_no;				/* u͂Ȃv̍s */
	int tech_no;				/* uƂ킴v̍s */
} mondata_t;

typedef struct monact_tag
{
	struct
	{
		size_t condition_size;		/* Kpf[^̃oCg */
		size_t action_size;			/* sp^[f[^̃oCg */
		unsigned char *condition;	/* Kpf[^ */
		unsigned char *action;		/* sp^[f[^ */
	} ptn[16];
} monact_t;

typedef struct monparty_tag
{
	int monster_no[8];			/* X^[̎ */
	int ability_point;			/* lAreB|Cg */
	int escape_rate;			/* ̂₷ */
	unsigned int bits_exist;	/* 퓬JnɃX^[oĂ邩 */
	int flag_escape;			/* \ł */
} monparty_t;

typedef struct monenc_tag
{
	int party_no[4];		/* X^[p[eB̎ */
} monenc_t;

typedef struct monmap_tag
{
	struct
	{
		int enc_no[4];
	} area[8][8];
} monmap_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monact_t *mon_readact(void);
monparty_t *mon_readparty(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeelem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writestate(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writefree(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writectrl(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writetech(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const monact_t *ptr_monact, const mondata_t *ptr_mondata);
int mon_writemes(const char *ptr_filename);
int mon_writeparty(const char *ptr_filename, const monparty_t *ptr_monparty);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);
void mon_freeact(monact_t *ptr_monact);

#endif /* FF5MONSTER_H */
