/*
 *	ff6decode.c
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "errmes.h"
#include "ff6decode.h"

/* t@Cit@^W[VI̕R[h\(VOoCg) */
static const char *tbl_charcode[] =
{
	"",   "\n", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "y",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "M",  "H",  "P",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!",  "F", "?",  "H", "A", "/",  ":",
	"u", "v", "B", "+",  "", "", "", "~", "", "", "", "", "", "", "", "",
	"E", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", " ",
};

/* t@Cit@^W[VI̕R[h\(bZ[WpE}`oCg1oCg) */
static const char *tbl_charcode_mb1[] =
{
	/* 0x00`0x1f */
	"", "\n", "eBi", "bN", "JCG", "VhE", "GhK[", "}bV",
	"ZX", "XgSX", "", "Zbc@[", "O", "KE", "SS", "E[}",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",

	/* 0x20`0xd7 */
	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "y",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "m",  "h",  "p",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!",  "F", "?",  "H", "A", "/",  ":",
	"u", "v", "B", "+",  "w", "(",  ")",  "E",

	/* 0xd8`0xff */
	"cc", "鍑", "", "", "b", "Ȃ", "", "E",
	"Ă", "KXgu", "PtJu", "", "", "", "oiu", "",
	"m", "ł", "Vhu", "̗", "", "Ă", "B", "l",
	"eBi", "bN", "JCG", "VhE", "GhK[", "}bV", "ZX", "XgSX",
	"", "Zbc@[", "O", "KE", "SS", "E[}", "EFbW", " ",
};

/* t@Cit@^W[VI̕R[h\(bZ[WpE}`oCg2oCg) */
static const char *tbl_charcode_mb2[] =
{
	/* 0x1c */
	"", "", "", "", "", "", "", "q", "", "", "t", "", "p", "Q", "", "",
	"v", "R", "", "m", "", "l", "", "b", "", "", "", "", "", "", "V", "",
	"", "", "{", "", "", "", "N", "", "", "", "", "z", "", "x", "", "J",
	"", "", "", "", "", "j", "", "", "", "", "D", "", "", "N", "c", "",
	"O", "`", "M", "", "", "l", "F", "", "@", "k", "A", "", "e", "D", "", "",
	"N", "", "", "", "", "", "", "", "X", "", "", "Z", "", "", "Z", "",
	"a", "", "", "n", "", "", "", "", "", "M", "", "", "", "", "^", "",
	"", "", "y", "a", "R", "", "s", "~", "", "v", "", "", "", "", "", "",
	"", "]", "", "g", "", "", "", "", "x", "", "", "", "K", "t", "", "s",
	"", "", "", "B", "", "", "", "", "", "I", "", "H", "v", "", "", "",
	"D", "`", "", "", "", "", "x", "}", "", "", "", "", "", "i", "", "",
	"X", "", "R", "", "", "t", "", "\", "p", "t", "h", "", "v", "", "", "",
	"I", "", "", "", "", "", "Y", "", "", "", "R", "A", "", "", "", "",
	"", "", "", "", "", "K", "~", "", "I", "", "i", "", "", "", "", "",
	"Y", "", "q", "", "V", "", "", "", "W", "", "", "", "", "", "", "`",
	"", "", "", "v", "", "W", "N", "", "", "", "B", "L", "", "L", "", "",

	/* 0x1d */
	"", "", "b", "", "p", "@", "", "", "", "Q", "", "", "", "t", "", "",
	"", "", "", "G", "", "E", "", "", "", "D", "", "k", "", "", "", "",
	"", "", "\", "y", "", "", "i", "", "S", "", "p", "[", "", "", "", "",
	"X", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "i", "", "", "Y", "~", "F", "", "", "X",
	"w", "", "", "u", "", "\", "", "p", "", "E", "", "\", "", "c", "", "S",
	"F", "", "", "", "", "H", "", "", "", "B", "", "", "i", "o", "", "",
	"A", "", "", "", "", "T", "", "q", "", "d", "", "", "", "u", "|", "",
	"c", "", "", "", "", "S", "", "", "", "e", "", "", "", "", "", "",
	"", "o", "\", "", "", "w", "O", "", "h", "P", "", "", "", "L", "R", "",
	"n", "h", "", "q", "", "", "", "", "p", "d", "t", "L", "", "", "", "P",
	"", "f", "", "", "", "", "k", "x", "", "", "", "", "", "", "r", "x",
	"", "G", "", "c", "", "", "", "t", "[", "", "", "", "@", "[", "l", "S",
	"", "", "", "", "`", "H", "", "", "c", "", "", "f", "D", "", "_", "",
	"", "^", "p", "", "", "", "", "", "A", "", "}", "", "", "E", " ",  " ",
	"X", "", "", "L", "", "", "", "", "", "O", "Q", "m", "", "", "", "",

	/* 0x1e */
	"h", "", "", "z", "s", "", "", "", "", "", "U", "", "", "m", "", "g",
	"", "", "", "", "", "", "", "", "", "", "", "o", "", "", "", "",
	"", "F", "g", "l", "", "", "", "", "", "", "", "S", "f", "", "", "",
	"", "E", "P", "", "", "", "", "", "G", "_", "", "|", "", "", "", "",
	"", "", "\", "{", "", "", "", "", "s", "", "", "", "", "", "", "",
	"A",  "B",  "X",  "Y",  "L",  "R",  "E",  "H",  "M",  "P",  "C",  "T",  "V",  "S",  "", "%",
	"", "", "", "", "", "", "", "", "m", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "J", "n", "Z", "^", "", "", "", "v", "", "",
	"", "", "", "e", "~", "", "", "", "", "", "", "", "", "", "", "",
	"", "C", "", "", "C", "S", "`", "Z", "", "", "", "", "", "", "", "",
	"", "", "", "", "c", "", "K", "", "", "", "E", "a", "", "", "C", "b",
	"", "", "", "^", "S", "_", "n", "w", "", "", "", "", "", "", "z", "u",
	"", "e", "f", "n", "", "", "", "V", "]", "{", "", "", "g", "j", "e", "",
	"", "", "", "K", "S", "", "", "@", "", "P", "", "", "", "", "", "",
	"", "d", "", "", "", "", "", "", "", "", "", "", "", "", "T", " ",
	"", "", "", "", "o", "", "Y", "", " ",  " ",  " ",  " ",  " ",  " ",  " ",  " ",

	/* 0x1f */
	"", "K", "", "", "", "q", "", "", "X", "", "K", "", "", "", "", " ",
	"", "", "", "", "H", "", "", "", "", "", "", "", "", "", "", " ",
	"o", "", "r", "", "u", "", "x", "", "{", "", "K", "", "M", "", "O", "",
	"Q", "", "S", "", "U", "", "W", "", "Y", "", "[", "", "]", "", "_", "",
	"a", "", "d", "", "f", "", "h", "", "", "p", "", "s", "", "v", "", "",
	"", "|", "", "0",  "1",  "2",  "3",  "4",  "5",  "6",  "7",  "8",  "9",  "m",  "h",  "p",
	"n", "", "q", "", "t", "", "w", "", "z", "", "J", "", "L", "", "N", "",
	"P", "", "R", "", "T", "", "V", "", "X", "", "Z", "", "\", "", "^", "",
	"`", "", "c", "", "e", "", "g", "", "E", "", "A", "", "C", "", "G", "",
	"I", "", "i", "", "j", "", "k", "", "l", "", "m", "", "}", "", "~", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
	"", "", "", "", "", "", "", "", "", "", "", "", "b", "", "", "",
	"", "", "", "", "@", "[", "B", "c", "D", "!",  "F", "?",  "H", "A", "/",  ":",
	"u", "v", "B", "\", "o", "", "", "", "", "", "a", "v", "J", "s", "I", "",
	"", "", "]", "", "", "", "", "", "j", "]", "", "", "", "", "", "",
	"`", "&",  "", "", "", "Y", "", "Y", "", "", "", "B", "", "O", "", " ",
};

char *dec_string(char *ptr_dstbuf, const unsigned char *ptr_srcbuf, size_t dstbufsize, size_t srcbufsize, int flag_multibyte)
{
	int i;
	char *buf_dstbuf = NULL;
	char *ptr = NULL;
	const size_t len_buf = srcbufsize * 8;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_charcode_mb1) / sizeof(tbl_charcode_mb1[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 1024);

	/* `FbN */
	if (ptr_dstbuf == NULL)
	{
		assert(0);
		return NULL;
	}
	if (ptr_srcbuf == NULL || srcbufsize == 0 || dstbufsize == 0)
	{
		assert(0);
		return ptr_dstbuf;
	}

	/* ꎞobt@mۂ */
	if ((buf_dstbuf = malloc(len_buf)) == NULL)
		err_printf(STR_FATAL_ERROR_IN_MALLOC);

	/* fR[h */
	memset(buf_dstbuf, '\0', sizeof(len_buf));
	if (!flag_multibyte)
	{
		for (i = 0; i < (int)srcbufsize; i++)
			strcat(buf_dstbuf, tbl_charcode[ptr_srcbuf[i]]);
	}
	else
	{
		for (i = 0; i < (int)srcbufsize; i++)
		{
			if (0x1c <= ptr_srcbuf[i] && ptr_srcbuf[i] <= 0x1f)
			{
				if (i < (int)srcbufsize - 1)
				{
					strcat(buf_dstbuf, tbl_charcode_mb2[((ptr_srcbuf[i] - 0x1c) << 8) | ptr_srcbuf[i + 1]]);
					i++;
				}
			}
			else if (ptr_srcbuf[i] == 0x02)	/* LN^̖OR[h */
			{
				i++;
				strcat(buf_dstbuf, tbl_charcode_mb1[ptr_srcbuf[i] + 0x02]);
			}
			else if (ptr_srcbuf[i] == 0x05)	/* EFCgR[h */
				;	/* o͂Ȃ */
			else if (ptr_srcbuf[i] == 0x07)
				;	/* o͂Ȃ */
			else if (ptr_srcbuf[i] == 0x01)	/* sR[h "/" Œu */
				strcat(buf_dstbuf, "/");
			else
				strcat(buf_dstbuf, tbl_charcode_mb1[ptr_srcbuf[i]]);
		}
	}

	/* ̋󔒂 */
	while ((ptr = strrchr(buf_dstbuf, ' ')) != NULL && *(ptr + 1) == '\0')
		*ptr = '\0';

	/* ꎞobt@̓eo͂ */
	strncpy(ptr_dstbuf, buf_dstbuf, dstbufsize - 1);
	ptr_dstbuf[dstbufsize - 1] = '\0';

	free(buf_dstbuf);
	buf_dstbuf = NULL;

	return ptr_dstbuf;
}

int dec_file(const char *ptr_readfilename, const char *ptr_writefilename, int flag_multibyte)
{
	int i, ch, ch2;
	FILE *fp_read  = NULL;
	FILE *fp_write = NULL;

	assert(sizeof(tbl_charcode) / sizeof(tbl_charcode[0]) == 256);
	assert(sizeof(tbl_charcode_mb1) / sizeof(tbl_charcode_mb1[0]) == 256);
	assert(sizeof(tbl_charcode_mb2) / sizeof(tbl_charcode_mb2[0]) == 1024);

	/* `FbN */
	if (ptr_readfilename == NULL || *ptr_readfilename == '\0' || ptr_writefilename == NULL || *ptr_writefilename == '\0')
	{
		assert(0);
		return 0;
	}

	/* fR[ht@CJ */
	if ((fp_read = fopen(ptr_readfilename, "rb")) == NULL)
		return 0;

	/* fR[hʂo͂t@CJ */
	if ((fp_write = fopen(ptr_writefilename, "w")) == NULL)
	{
		fclose(fp_read);
		fp_read = NULL;
		return 0;
	}

	/* fR[h */
	if (!flag_multibyte)
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode[ch], fp_write);
		}
	}
	else
	{
		while ((ch = fgetc(fp_read)) != EOF)
		{
			if (0x1c <= ch && ch <= 0x1f)	/* }`oCg */
			{
				if ((ch2 = fgetc(fp_read)) == EOF)
					break;

				fputs(tbl_charcode_mb2[((ch - 0x1c) << 8) | ch2], fp_write);
			}
			else if (ch == 0x14)	/* A󔒂R[h */
			{
				if ((ch2 = fgetc(fp_read)) == EOF)
					break;

				for (i = 0; i < ch2; i++)
					fputs(tbl_charcode_mb1[0xff], fp_write);
			}
			else if (ch == 0x13)	/* y[WR[h */
				fputs("\n\n", fp_write);
			else if (ch == 0x15)	/* J[\R[h */
				fputs("", fp_write);
			else if (ch == 0x10)	/* R[h */
				;	/* o͂Ȃ */
			else if (ch == 0x11 || ch == 0x16)	/* R[h */
			{
				/* 2ǂݔ΂ */
				if (fgetc(fp_read) == EOF || fgetc(fp_read) == EOF)
					break;
			}
			else if (ch == 0x00)	/* Kxɉs邽 */
				fputc('\n', fp_write);
			else
				fputs(tbl_charcode_mb1[ch], fp_write);
		}
	}

	fclose(fp_read);
	fclose(fp_write);
	fp_read  = NULL;
	fp_write = NULL;

	return 1;
}
