/*
 *	ff6define.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF6DEFINE_H)
#define FF6DEFINE_H

enum
{
	ELEM_IDX_FIRE,		/*  */
	ELEM_IDX_ICE,		/* X */
	ELEM_IDX_THUNDER,	/*  */
	ELEM_IDX_POISON,	/*  */
	ELEM_IDX_WIND,		/*  */
	ELEM_IDX_SACRED,	/*  */
	ELEM_IDX_EARTH,		/* n */
	ELEM_IDX_WATER,		/*  */

	NUM_ELEMENT
};

enum
{
	STATE_IDX_DARKNESS,		/* È */
	STATE_IDX_ZOMBIE,		/* ]r[ */
	STATE_IDX_POISON,		/* ғ */
	STATE_IDX_UNKNOWN1,		/* s1 */
	STATE_IDX_VANISH,		/*  */
	STATE_IDX_KAPPA,		/* Jbp */
	STATE_IDX_STONE,		/* Ή */
	STATE_IDX_SWOON,		/* 퓬s\ */

	STATE_IDX_BECOME_DEATH,	/* ̐鍐 */
	STATE_IDX_DEADLY,		/* m */
	STATE_IDX_ILLUSION,		/* g */
	STATE_IDX_SILENT,		/*  */
	STATE_IDX_BERSERK,		/* o[TN */
	STATE_IDX_CONFUSE,		/*  */
	STATE_IDX_SLIP,			/* Xbv */
	STATE_IDX_SLEEP,		/*  */

	STATE_IDX_FLYING,		/* ł */
	STATE_IDX_REGENERATION,	/* WFl */
	STATE_IDX_SLOW,			/* XE */
	STATE_IDX_HASTE,		/* wCXg */
	STATE_IDX_STOP,			/* Xgbv */
	STATE_IDX_SHELL,		/* VF */
	STATE_IDX_PROTECT,		/* veX */
	STATE_IDX_REFLECT,		/* tN */

	STATE_IDX_NOUSE1,		/* gp1 */
	STATE_IDX_FREEZING,		/* XÂ */
	STATE_IDX_RERAISE,		/* CY */
	STATE_IDX_NOUSE2,		/* gp2 */
	STATE_IDX_NOUSE3,		/* gp3 */
	STATE_IDX_EXIT,			/* E */
	STATE_IDX_UNKNOWN2,		/* s2 */
	STATE_IDX_LEVITATE,		/* reg */

	NUM_STATE
};

#define ELEM_FIRE		(1U << ELEM_IDX_FIRE)
#define ELEM_ICE		(1U << ELEM_IDX_ICE)
#define ELEM_THUNDER	(1U << ELEM_IDX_THUNDER)
#define ELEM_POISON		(1U << ELEM_IDX_POISON)
#define ELEM_WIND		(1U << ELEM_IDX_WIND)
#define ELEM_SACRED		(1U << ELEM_IDX_SACRED)
#define ELEM_EARTH		(1U << ELEM_IDX_EARTH)
#define ELEM_WATER		(1U << ELEM_IDX_WATER)
#define ELEM_ALL		(ELEM_FIRE	| ELEM_ICE		| ELEM_THUNDER	| ELEM_POISON	| \
						ELEM_WIND	| ELEM_SACRED	| ELEM_EARTH	| ELEM_WATER)

#define STATE_DARKNESS		(1U << STATE_IDX_DARKNESS)
#define STATE_ZOMBIE		(1U << STATE_IDX_ZOMBIE)
#define STATE_POISON		(1U << STATE_IDX_POISON)
#define STATE_UNKNOWN1		(1U << STATE_IDX_UNKNOWN1)
#define STATE_VANISH		(1U << STATE_IDX_VANISH)
#define STATE_KAPPA			(1U << STATE_IDX_KAPPA)
#define STATE_STONE			(1U << STATE_IDX_STONE)
#define STATE_SWOON			(1U << STATE_IDX_SWOON)
#define STATE_PERMANENT		(STATE_DARKNESS	| STATE_ZOMBIE	| STATE_POISON	| STATE_UNKNOWN1	| \
							STATE_VANISH	| STATE_KAPPA	| STATE_STONE	| STATE_SWOON)

#define STATE_BECOME_DEATH	(1U << STATE_IDX_BECOME_DEATH)
#define STATE_DEADLY		(1U << STATE_IDX_DEADLY)
#define STATE_ILLUSION		(1U << STATE_IDX_ILLUSION)
#define STATE_SILENT		(1U << STATE_IDX_SILENT)
#define STATE_BERSERK		(1U << STATE_IDX_BERSERK)
#define STATE_CONFUSE		(1U << STATE_IDX_CONFUSE)
#define STATE_SLIP			(1U << STATE_IDX_SLIP)
#define STATE_SLEEP			(1U << STATE_IDX_SLEEP)
#define STATE_TEMPORARY		(STATE_BECOME_DEATH	| STATE_DEADLY	| STATE_ILLUSION	| STATE_SILENT	| \
							STATE_BERSERK		| STATE_CONFUSE	| STATE_SLIP		| STATE_SLEEP)

#define STATE_FLYING		(1U << STATE_IDX_FLYING)
#define STATE_REGENERATION	(1U << STATE_IDX_REGENERATION)
#define STATE_SLOW			(1U << STATE_IDX_SLOW)
#define STATE_HASTE			(1U << STATE_IDX_HASTE)
#define STATE_STOP			(1U << STATE_IDX_STOP)
#define STATE_SHELL			(1U << STATE_IDX_SHELL)
#define STATE_PROTECT		(1U << STATE_IDX_PROTECT)
#define STATE_REFLECT		(1U << STATE_IDX_REFLECT)
#define STATE_ASSISTMAG		(STATE_FLYING	| STATE_REGENERATION	| STATE_SLOW	| STATE_HASTE	| \
							STATE_STOP		| STATE_SHELL			| STATE_PROTECT	| STATE_REFLECT)

#define STATE_FREEZING		(1U << STATE_IDX_FREEZING)
#define STATE_RERAISE		(1U << STATE_IDX_RERAISE)
#define STATE_EXIT			(1U << STATE_IDX_EXIT)
#define STATE_UNKNOWN2		(1U << STATE_IDX_UNKNOWN2)
#define STATE_LEVITATE		(1U << STATE_IDX_LEVITATE)
#define STATE_OTHER			(STATE_FREEZING | STATE_RERAISE | STATE_EXIT | STATE_UNKNOWN2 | STATE_LEVITATE)

#define STATE_ALL			(STATE_PERMANENT | STATE_TEMPORARY | STATE_ASSISTMAG | STATE_OTHER)

typedef unsigned long elem_t;
typedef unsigned long state_t;

const char *str_getflag(int flag);
const char *str_getelem(elem_t elem, int index);
void str_printelem(FILE *stream, elem_t elem, elem_t elem_mask);
const char *str_getstate(state_t state, int index);
void str_printstate(FILE *stream, state_t state, state_t state_mask);

#define bits_make32(byte1, byte2, byte3, byte4)	(((unsigned long)(byte1) & 0xff) | \
												(((unsigned long)(byte2) & 0xff) <<  8) | \
												(((unsigned long)(byte3) & 0xff) << 16) | \
												(((unsigned long)(byte4) & 0xff) << 24))

#endif /* FF6DEFINE_H */
