/*
 *	ff6monster.h
 *		Copyright (C)2000-2002 Shingo Endo <s-endo@yk.rim.or.jp>
 */

#if !defined(FF6MONSTER_H)
#define FF6MONSTER_H

#include "ff6define.h"
#include "ff6item.h"
#include "ff6magic.h"

typedef struct mondata_tag
{
	int level;					/* x */
	long hit_point;				/* qbg|Cg */
	long magic_point;			/* }WbN|Cg */
	long experience_point;		/* lol */
	long gil;					/* M */
	int speed;					/* f */
	int attack_power;			/* U */
	int defense_power;			/* h */
	int evade_rate;				/*  */
	int magic_attack_power;		/* @U */
	int magic_defense_power;	/* @h */
	int magic_evade_rate;		/* @ */
	int hit_rate;				/* qbgl */
	int item_metamorph;			/* ACeὠՓx */
	elem_t elem_none;			/*  */
	elem_t elem_absorb;			/* z */
	elem_t elem_double;			/* _ */
	state_t state_defense;		/* ԕωւ̑ϐ */
	state_t state_apriori;		/* ŏKpԕω */
	int flag_undead;			/* Afbhnł */
	int flag_human;				/* lԌnł */
	int flag_mp0;				/* }WbN|Cg0ɂƓ| */
	int flag_erase_name;		/* O\Ȃ */
	int flag_escape;			/* \ł */
	int item_no[4];				/* ACe */
	int ragna_item_no[4];		/* ωACe */
	int control_no[4];			/* uv̍s */
	int sketch_no[2];			/* uXPb`v̍s */
	int rage_no[2];				/* u΂v̍s */
	int tech_no;				/* uƂv̍s */
} mondata_t;

typedef struct monact_tag
{
	int ptn_num;
	struct
	{
		size_t action_size;		/* sp^[f[^̃oCg */
		unsigned char *action;	/* sp^[f[^ */
	} ptn[24];
} monact_t;

typedef struct monparty_tag
{
	int monster_no[6];			/* X^[̎ */
	int magic_learning_gain;	/* @Cl */
	unsigned int bits_exist;	/* 퓬JnɃX^[oĂ邩 */
	int flag_normal;			/* ʏ퓬̉\ */
	int flag_backattack;		/* obNA^bN̉\ */
	int flag_pincer;			/* ݂͂̉\ */
	int flag_sideattack;		/* TChA^bN̉\ */
	int flag_beastfield;		/* bɏo邩ǂ(sm) */
} monparty_t;

typedef struct monenc_tag
{
	int party_no[4];	/* X^[p[eB̎ */
} monenc_t;

typedef struct monmap_tag
{
	struct
	{
		int enc_no[4];
	} area[8][8];
} monmap_t;

const char *mon_getname(int index);
mondata_t *mon_readdata(void);
monact_t *mon_readact(void);
monparty_t *mon_readparty(void);
monenc_t *mon_readenc(void);
monmap_t *mon_readmap(void);
int mon_writeparam(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeelem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writestate(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeflag(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeitem(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeragna(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writectrl(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writesketch(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writerage(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writemisc(const char *ptr_filename, const mondata_t *ptr_mondata);
int mon_writeact(const char *ptr_filename, const monact_t *ptr_monact, const mondata_t *ptr_mondata);
int mon_writemes(const char *ptr_filename);
int mon_writeevent(const char *ptr_filename);
int mon_writeparty(const char *ptr_filename, const monparty_t *ptr_monparty);
int mon_writeenc(const char *ptr_filename, const monenc_t *ptr_monenc, const monparty_t *ptr_monparty);
int mon_writemap(const char *ptr_filename, const monmap_t *ptr_monmap);
void mon_freeact(monact_t *ptr_monact);

#endif /* FF6MONSTER_H */
